package boxtexture;

import java.io.IOException;

import javax.media.opengl.GL2;
import javax.media.opengl.GLAutoDrawable;
import javax.media.opengl.GLEventListener;

import com.jogamp.opengl.util.texture.Texture;
import com.jogamp.opengl.util.texture.TextureIO;

public class GLRenderer implements GLEventListener {

	private int a = 0;

	@Override
	public void init(GLAutoDrawable drawable) {
		GL2 gl = drawable.getGL().getGL2();

		// attiva il test di profondit per disegnare solo le parti visibili
		gl.glEnable(GL2.GL_DEPTH_TEST);
		// abilita il texturing delle superfici
		gl.glEnable(GL2.GL_TEXTURE_2D);
		// carica l'immagine e imposta la texture
		try {
			Texture texture = TextureIO.newTexture(Main.class.getResource("/boxtexture/img/Pieghe.jpg"), true, "jpg");
			gl.glBindTexture(GL2.GL_TEXTURE_2D, texture.getTextureObject(gl));
		} catch (IOException e) {
			e.printStackTrace();
		}
	}

	@Override
	public void dispose(GLAutoDrawable drawable) {
	}

	@Override
	public void display(GLAutoDrawable drawable) {
		GL2 gl = drawable.getGL().getGL2();

		// cancella l'immagine e il buffer per il test di profondit
		gl.glClear(GL2.GL_COLOR_BUFFER_BIT | GL2.GL_DEPTH_BUFFER_BIT);

		gl.glLoadIdentity();
		gl.glRotated(30, 1, 0, 0);	// rotazione fissa di 30 intorno a X
		gl.glRotated(a, 0, 1, 0);	// rotazione variabile di a intorno a Y

		gl.glBegin(GL2.GL_QUADS);

		// faccia davanti
		gl.glTexCoord2d(0, 0);
		gl.glVertex3d(-1, -1, 1);
		gl.glTexCoord2d(1, 0);
		gl.glVertex3d(1, -1, 1);
		gl.glTexCoord2d(1, 1);
		gl.glVertex3d(1, 1, 1);
		gl.glTexCoord2d(0, 1);
		gl.glVertex3d(-1, 1, 1);

		// faccia destra
		gl.glTexCoord2d(1, 0);
		gl.glVertex3d(1, -1, 1);
		gl.glTexCoord2d(0, 0);
		gl.glVertex3d(1, -1, -1);
		gl.glTexCoord2d(0, 1);
		gl.glVertex3d(1, 1, -1);
		gl.glTexCoord2d(1, 1);
		gl.glVertex3d(1, 1, 1);

		// faccia dietro
		gl.glTexCoord2d(0, 0);
		gl.glVertex3d(1, -1, -1);
		gl.glTexCoord2d(1, 0);
		gl.glVertex3d(-1, -1, -1);
		gl.glTexCoord2d(1, 1);
		gl.glVertex3d(-1, 1, -1);
		gl.glTexCoord2d(0, 1);
		gl.glVertex3d(1, 1, -1);

		// faccia sinistra
		gl.glTexCoord2d(1, 0);
		gl.glVertex3d(-1, -1, -1);
		gl.glTexCoord2d(0, 0);
		gl.glVertex3d(-1, -1, 1);
		gl.glTexCoord2d(0, 1);
		gl.glVertex3d(-1, 1, 1);
		gl.glTexCoord2d(1, 1);
		gl.glVertex3d(-1, 1, -1);
 
		gl.glEnd();

		a++;
	}

	@Override
	public void reshape(GLAutoDrawable drawable, int x, int y, int w, int h) {
		GL2 gl = drawable.getGL().getGL2();

		// imposta la matrice di trasformazione per la proiezione
		gl.glMatrixMode(GL2.GL_PROJECTION);
		gl.glLoadIdentity();
		gl.glOrtho(-2.0 * w / h, 2.0 * w / h, -2.0, 2.0, -2.0, 2.0);

		// imposta la matrice di trasformazione per gli oggetti
		gl.glMatrixMode(GL2.GL_MODELVIEW);
		gl.glLoadIdentity();
	}

}
